> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Create shifts

POST https://api.letsdeel.com/rest/v2/time_tracking/shifts
Content-Type: application/json

Creates multiple time tracking shifts for a contract, supporting both regular shift submissions and corrections that adjust hours for previously processed shifts.

 **Token scopes**: `time-tracking:write`

Reference: https://developer.deel.com/api/endpoints/time-tracking-shifts/create-time-tracking-shifts

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Body (application/json)

This endpoint expects an object.

- `data` (V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaData, required)

## Response

### 201

Successful operation.

- `data` (list of V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItems, required)

## Errors

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

## Types

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaData

- `shifts` (list of V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItems, required)
- `contract_id` (string, required) — The unique identifier of the employee contract.

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItems

- `created_at` (string, required) — Date when the shift was created
- `shift_type` (enum, required) — Type of the shift
  - Allowed values: `REGULAR`, `CORRECTION_ABSOLUTE`, `CORRECTION_DELTA`
- `updated_at` (string, required) — Date when the shift was last updated
- `contract_id` (string, required) — Associated contract ID for the shift
- `description` (string, required) — Description of the shift
- `external_id` (string, required) — ID specified by the client for uniquely identifying the shift
- `date_of_work` (string, required) — Date when the shift takes place, in YYYY-MM-DD format
- `meta` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMeta, optional)
- `summary` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsSummary, optional)
- `payroll_cycle_ref` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsPayrollCycleRef, optional) — Payroll cycle reference
- `shift_reference_id` (string, optional) — External ID of the original shift this one references (set on correction shifts).

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItems

- `shift_type`: `REGULAR` (REGULAR)
  - `date_of_work` (string, required)
  - `description` (string, required) — Description of the shift.
  - `external_id` (string, required) — External ID of the shift.
  - `summary` (V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf0Summary, required) — Shift summary
  - `payroll_cycle_ref` (V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf0PayrollCycleRef, optional) — Payroll cycle reference
- `shift_type`: `CORRECTION_ABSOLUTE` (CORRECTION_ABSOLUTE)
  - `description` (string, required) — Description of the shift.
  - `external_id` (string, required) — External ID of the shift.
  - `shift_reference_id` (string, required) — External ID of the original shift being corrected.
  - `summary` (V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf1Summary, required)
  - `payroll_cycle_ref` (V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf1PayrollCycleRef, optional) — Payroll cycle reference
- `shift_type`: `CORRECTION_DELTA` (CORRECTION_DELTA)
  - `corrections` (list of V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf2CorrectionsItems, required)
  - `description` (string, required) — Description of the shift.
  - `external_id` (string, required) — External ID of the shift.
  - `shift_reference_id` (string, required) — External ID of the original shift being corrected.
  - `payroll_cycle_ref` (V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf2PayrollCycleRef, optional) — Payroll cycle reference

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMeta

- `end` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaEnd, required)
- `start` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaStart, required)
- `breaks` (list of V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems, optional)
- `approval_date` (string, optional) — Approval date for the shift, in ISO format

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsSummary

- `shift_rate_external_id` (string, required) — External ID of the shift rate associated with this shift
- `time_unit` (enum, optional) — The unit of time for the shift (DAY, HOUR, MONTH, WEEK)
  - Allowed values: `DAY`, `HOUR`, `MONTH`, `WEEK`
- `time_amount` (double, optional) — The amount of time for the shift
- `total_break_hours` (double, optional) — Total break duration in hours
- `payable_break_hours` (double, optional) — Break hours that are payable
- `total_payable_hours` (double, optional) — Total payable working hours after break deductions
- `shift_duration_hours` (double, optional) — Total duration of the shift in hours

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsPayrollCycleRef

Payroll cycle reference

- `date` (string, required) — date in ISO

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf0Summary

Shift summary

- `time_unit` (enum, optional) — The unit of time for the shift (DAY, HOUR, MONTH, WEEK)
  - Allowed values: `DAY`, `HOUR`, `MONTH`, `WEEK`
- `time_amount` (double, optional) — The amount of time for the shift
- `total_break_hours` (double, optional) — Total break duration in hours
- `payable_break_hours` (double, optional) — Break hours that are payable
- `total_payable_hours` (double, optional) — Total payable working hours after break deductions
- `shift_duration_hours` (double, optional) — Total duration of the shift in hours
- `shift_rate_external_id` (string, optional) — External ID of the shift rate associated with this

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf0PayrollCycleRef

Payroll cycle reference

- `date` (string, required) — date in ISO

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf1Summary

- `time_unit` (enum, optional) — The unit of time for the shift (DAY, HOUR, MONTH, WEEK)
  - Allowed values: `DAY`, `HOUR`, `MONTH`, `WEEK`
- `time_amount` (double, optional) — The amount of time for the shift
- `total_break_hours` (double, optional) — Total break duration in hours
- `payable_break_hours` (double, optional) — Break hours that are payable
- `total_payable_hours` (double, optional) — Total payable working hours after break deductions
- `shift_duration_hours` (double, optional) — Total duration of the shift in hours

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf1PayrollCycleRef

Payroll cycle reference

- `date` (string, required) — date in ISO

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf2CorrectionsItems

Correction entry for delta shifts

- `type` (enum, required) — Type of correction
  - Allowed values: `ADDITION`, `SUBTRACTION`
- `time_amount` (double, optional) — Time amount to add or subtract
- `total_break_hours` (double, optional) — Break hours to add or subtract
- `payable_break_hours` (double, optional) — Payable break hours to add or subtract
- `total_payable_hours` (double, optional) — Payable hours to add or subtract
- `shift_duration_hours` (double, optional) — Shift duration hours to add or subtract

### V2TimeTrackingShiftsPostRequestBodyContentApplicationJsonSchemaDataShiftsItemsOneOf2PayrollCycleRef

Payroll cycle reference

- `date` (string, required) — date in ISO

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaEnd

- `date` (string, required) — Shift end date
- `time` (string, required) — Shift end time in HH:mm format
- `is_rest_day` (boolean, required) — Indicates if it is a rest day
- `is_public_holiday` (boolean, required) — Indicates if it is a public holiday

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaStart

- `date` (string, required) — Shift start date
- `time` (string, required) — Shift start time in HH:mm format
- `is_rest_day` (boolean, required) — Indicates if it is a rest day
- `is_public_holiday` (boolean, required) — Indicates if it is a public holiday

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems

- `end` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd, required)
- `start` (V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart, required)
- `is_paid` (boolean, optional) — Indicates if the break is paid

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd

- `date` (string, required) — Break end date
- `time` (string, required) — Break end time in HH:mm format

### V2TimeTrackingShiftsPostResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart

- `date` (string, required) — Break start date
- `time` (string, required) — Break start time in HH:mm format

## Examples

**Request**

```json
{
  "data": {
    "shifts": [
      {
        "shift_type": "REGULAR",
        "date_of_work": "2023-10-01",
        "description": "This is a sample shift description.",
        "external_id": "shift_123d47dewdwe",
        "summary": {
          "total_break_hours": 1,
          "payable_break_hours": 0.5,
          "total_payable_hours": 7.5,
          "shift_duration_hours": 8,
          "shift_rate_external_id": "id1shiftrsate1"
        },
        "payroll_cycle_ref": {
          "date": "2023-10-31T12:00:00.000Z"
        }
      }
    ],
    "contract_id": "35edggp"
  }
}
```

**Response**

```json
{
  "data": [
    {
      "created_at": "2024-02-01T00:00:00.000Z",
      "shift_type": "REGULAR",
      "updated_at": "2024-02-10T00:00:00.000Z",
      "contract_id": "contract-id-456",
      "description": "Night shift at warehouse",
      "external_id": "external-id-123",
      "date_of_work": "2024-02-12",
      "meta": {
        "end": {
          "date": "2024-02-12",
          "time": "16:00",
          "is_rest_day": false,
          "is_public_holiday": false
        },
        "start": {
          "date": "2024-02-12",
          "time": "08:00",
          "is_rest_day": false,
          "is_public_holiday": false
        },
        "breaks": [
          {
            "end": {
              "date": "12:30",
              "time": "12:30"
            },
            "start": {
              "date": "2024-02-12",
              "time": "12:00"
            },
            "is_paid": true
          }
        ],
        "approval_date": "2024-02-11T12:00:00.000Z"
      },
      "summary": {
        "shift_rate_external_id": "shift-rate-id-789",
        "time_unit": "HOUR",
        "time_amount": 8,
        "total_break_hours": 0.5,
        "payable_break_hours": 0.5,
        "total_payable_hours": 7.5,
        "shift_duration_hours": 8
      },
      "payroll_cycle_ref": {
        "date": "2024-02-11T12:00:00.000Z"
      },
      "shift_reference_id": "shift-ref-123"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/v2/time_tracking/shifts"

payload = { "data": {
        "shifts": [
            {
                "shift_type": "REGULAR",
                "date_of_work": "2023-10-01",
                "description": "This is a sample shift description.",
                "external_id": "shift_123d47dewdwe",
                "summary": {
                    "total_break_hours": 1,
                    "payable_break_hours": 0.5,
                    "total_payable_hours": 7.5,
                    "shift_duration_hours": 8,
                    "shift_rate_external_id": "id1shiftrsate1"
                },
                "payroll_cycle_ref": { "date": "2023-10-31T12:00:00.000Z" }
            }
        ],
        "contract_id": "35edggp"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/time_tracking/shifts';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"shifts":[{"shift_type":"REGULAR","date_of_work":"2023-10-01","description":"This is a sample shift description.","external_id":"shift_123d47dewdwe","summary":{"total_break_hours":1,"payable_break_hours":0.5,"total_payable_hours":7.5,"shift_duration_hours":8,"shift_rate_external_id":"id1shiftrsate1"},"payroll_cycle_ref":{"date":"2023-10-31T12:00:00.000Z"}}],"contract_id":"35edggp"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/time_tracking/shifts"

	payload := strings.NewReader("{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"shift_type\": \"REGULAR\",\n        \"date_of_work\": \"2023-10-01\",\n        \"description\": \"This is a sample shift description.\",\n        \"external_id\": \"shift_123d47dewdwe\",\n        \"summary\": {\n          \"total_break_hours\": 1,\n          \"payable_break_hours\": 0.5,\n          \"total_payable_hours\": 7.5,\n          \"shift_duration_hours\": 8,\n          \"shift_rate_external_id\": \"id1shiftrsate1\"\n        },\n        \"payroll_cycle_ref\": {\n          \"date\": \"2023-10-31T12:00:00.000Z\"\n        }\n      }\n    ],\n    \"contract_id\": \"35edggp\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/time_tracking/shifts")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"shift_type\": \"REGULAR\",\n        \"date_of_work\": \"2023-10-01\",\n        \"description\": \"This is a sample shift description.\",\n        \"external_id\": \"shift_123d47dewdwe\",\n        \"summary\": {\n          \"total_break_hours\": 1,\n          \"payable_break_hours\": 0.5,\n          \"total_payable_hours\": 7.5,\n          \"shift_duration_hours\": 8,\n          \"shift_rate_external_id\": \"id1shiftrsate1\"\n        },\n        \"payroll_cycle_ref\": {\n          \"date\": \"2023-10-31T12:00:00.000Z\"\n        }\n      }\n    ],\n    \"contract_id\": \"35edggp\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/time_tracking/shifts")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"shift_type\": \"REGULAR\",\n        \"date_of_work\": \"2023-10-01\",\n        \"description\": \"This is a sample shift description.\",\n        \"external_id\": \"shift_123d47dewdwe\",\n        \"summary\": {\n          \"total_break_hours\": 1,\n          \"payable_break_hours\": 0.5,\n          \"total_payable_hours\": 7.5,\n          \"shift_duration_hours\": 8,\n          \"shift_rate_external_id\": \"id1shiftrsate1\"\n        },\n        \"payroll_cycle_ref\": {\n          \"date\": \"2023-10-31T12:00:00.000Z\"\n        }\n      }\n    ],\n    \"contract_id\": \"35edggp\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/time_tracking/shifts', [
  'body' => '{
  "data": {
    "shifts": [
      {
        "shift_type": "REGULAR",
        "date_of_work": "2023-10-01",
        "description": "This is a sample shift description.",
        "external_id": "shift_123d47dewdwe",
        "summary": {
          "total_break_hours": 1,
          "payable_break_hours": 0.5,
          "total_payable_hours": 7.5,
          "shift_duration_hours": 8,
          "shift_rate_external_id": "id1shiftrsate1"
        },
        "payroll_cycle_ref": {
          "date": "2023-10-31T12:00:00.000Z"
        }
      }
    ],
    "contract_id": "35edggp"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/time_tracking/shifts");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"shifts\": [\n      {\n        \"shift_type\": \"REGULAR\",\n        \"date_of_work\": \"2023-10-01\",\n        \"description\": \"This is a sample shift description.\",\n        \"external_id\": \"shift_123d47dewdwe\",\n        \"summary\": {\n          \"total_break_hours\": 1,\n          \"payable_break_hours\": 0.5,\n          \"total_payable_hours\": 7.5,\n          \"shift_duration_hours\": 8,\n          \"shift_rate_external_id\": \"id1shiftrsate1\"\n        },\n        \"payroll_cycle_ref\": {\n          \"date\": \"2023-10-31T12:00:00.000Z\"\n        }\n      }\n    ],\n    \"contract_id\": \"35edggp\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "shifts": [
      [
        "shift_type": "REGULAR",
        "date_of_work": "2023-10-01",
        "description": "This is a sample shift description.",
        "external_id": "shift_123d47dewdwe",
        "summary": [
          "total_break_hours": 1,
          "payable_break_hours": 0.5,
          "total_payable_hours": 7.5,
          "shift_duration_hours": 8,
          "shift_rate_external_id": "id1shiftrsate1"
        ],
        "payroll_cycle_ref": ["date": "2023-10-31T12:00:00.000Z"]
      ]
    ],
    "contract_id": "35edggp"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/time_tracking/shifts")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```